/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package it.tref.liferay.mapit.map.service.persistence;

import com.liferay.portal.kernel.cache.CacheRegistryUtil;
import com.liferay.portal.kernel.dao.orm.EntityCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderPath;
import com.liferay.portal.kernel.dao.orm.Query;
import com.liferay.portal.kernel.dao.orm.QueryPos;
import com.liferay.portal.kernel.dao.orm.QueryUtil;
import com.liferay.portal.kernel.dao.orm.Session;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.InstanceFactory;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.kernel.util.PropsKeys;
import com.liferay.portal.kernel.util.PropsUtil;
import com.liferay.portal.kernel.util.SetUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.kernel.util.StringUtil;
import com.liferay.portal.kernel.util.UnmodifiableList;
import com.liferay.portal.kernel.util.Validator;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.ModelListener;
import com.liferay.portal.service.persistence.impl.BasePersistenceImpl;

import it.tref.liferay.mapit.map.NoSuchPluginException;
import it.tref.liferay.mapit.map.model.Plugin;
import it.tref.liferay.mapit.map.model.impl.PluginImpl;
import it.tref.liferay.mapit.map.model.impl.PluginModelImpl;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Set;

/**
 * The persistence implementation for the plugin service.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author
 * @see PluginPersistence
 * @see PluginUtil
 * @generated
 */
public class PluginPersistenceImpl extends BasePersistenceImpl<Plugin>
	implements PluginPersistence {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. Always use {@link PluginUtil} to access the plugin persistence. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this class.
	 */
	public static final String FINDER_CLASS_NAME_ENTITY = PluginImpl.class.getName();
	public static final String FINDER_CLASS_NAME_LIST_WITH_PAGINATION = FINDER_CLASS_NAME_ENTITY +
		".List1";
	public static final String FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION = FINDER_CLASS_NAME_ENTITY +
		".List2";
	public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_ALL = new FinderPath(PluginModelImpl.ENTITY_CACHE_ENABLED,
			PluginModelImpl.FINDER_CACHE_ENABLED, PluginImpl.class,
			FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findAll", new String[0]);
	public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_ALL = new FinderPath(PluginModelImpl.ENTITY_CACHE_ENABLED,
			PluginModelImpl.FINDER_CACHE_ENABLED, PluginImpl.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "findAll", new String[0]);
	public static final FinderPath FINDER_PATH_COUNT_ALL = new FinderPath(PluginModelImpl.ENTITY_CACHE_ENABLED,
			PluginModelImpl.FINDER_CACHE_ENABLED, Long.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countAll", new String[0]);
	public static final FinderPath FINDER_PATH_FETCH_BY_CONTEXT = new FinderPath(PluginModelImpl.ENTITY_CACHE_ENABLED,
			PluginModelImpl.FINDER_CACHE_ENABLED, PluginImpl.class,
			FINDER_CLASS_NAME_ENTITY, "fetchByContext",
			new String[] { String.class.getName() },
			PluginModelImpl.CONTEXT_COLUMN_BITMASK);
	public static final FinderPath FINDER_PATH_COUNT_BY_CONTEXT = new FinderPath(PluginModelImpl.ENTITY_CACHE_ENABLED,
			PluginModelImpl.FINDER_CACHE_ENABLED, Long.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countByContext",
			new String[] { String.class.getName() });

	/**
	 * Returns the plugin where context = &#63; or throws a {@link it.tref.liferay.mapit.map.NoSuchPluginException} if it could not be found.
	 *
	 * @param context the context
	 * @return the matching plugin
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginException if a matching plugin could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public Plugin findByContext(String context)
		throws NoSuchPluginException, SystemException {
		Plugin plugin = fetchByContext(context);

		if (plugin == null) {
			StringBundler msg = new StringBundler(4);

			msg.append(_NO_SUCH_ENTITY_WITH_KEY);

			msg.append("context=");
			msg.append(context);

			msg.append(StringPool.CLOSE_CURLY_BRACE);

			if (_log.isWarnEnabled()) {
				_log.warn(msg.toString());
			}

			throw new NoSuchPluginException(msg.toString());
		}

		return plugin;
	}

	/**
	 * Returns the plugin where context = &#63; or returns <code>null</code> if it could not be found. Uses the finder cache.
	 *
	 * @param context the context
	 * @return the matching plugin, or <code>null</code> if a matching plugin could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public Plugin fetchByContext(String context) throws SystemException {
		return fetchByContext(context, true);
	}

	/**
	 * Returns the plugin where context = &#63; or returns <code>null</code> if it could not be found, optionally using the finder cache.
	 *
	 * @param context the context
	 * @param retrieveFromCache whether to use the finder cache
	 * @return the matching plugin, or <code>null</code> if a matching plugin could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public Plugin fetchByContext(String context, boolean retrieveFromCache)
		throws SystemException {
		Object[] finderArgs = new Object[] { context };

		Object result = null;

		if (retrieveFromCache) {
			result = FinderCacheUtil.getResult(FINDER_PATH_FETCH_BY_CONTEXT,
					finderArgs, this);
		}

		if (result instanceof Plugin) {
			Plugin plugin = (Plugin)result;

			if (!Validator.equals(context, plugin.getContext())) {
				result = null;
			}
		}

		if (result == null) {
			StringBundler query = new StringBundler(3);

			query.append(_SQL_SELECT_PLUGIN_WHERE);

			boolean bindContext = false;

			if (context == null) {
				query.append(_FINDER_COLUMN_CONTEXT_CONTEXT_1);
			}
			else if (context.equals(StringPool.BLANK)) {
				query.append(_FINDER_COLUMN_CONTEXT_CONTEXT_3);
			}
			else {
				bindContext = true;

				query.append(_FINDER_COLUMN_CONTEXT_CONTEXT_2);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				if (bindContext) {
					qPos.add(context);
				}

				List<Plugin> list = q.list();

				if (list.isEmpty()) {
					FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_CONTEXT,
						finderArgs, list);
				}
				else {
					Plugin plugin = list.get(0);

					result = plugin;

					cacheResult(plugin);

					if ((plugin.getContext() == null) ||
							!plugin.getContext().equals(context)) {
						FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_CONTEXT,
							finderArgs, plugin);
					}
				}
			}
			catch (Exception e) {
				FinderCacheUtil.removeResult(FINDER_PATH_FETCH_BY_CONTEXT,
					finderArgs);

				throw processException(e);
			}
			finally {
				closeSession(session);
			}
		}

		if (result instanceof List<?>) {
			return null;
		}
		else {
			return (Plugin)result;
		}
	}

	/**
	 * Removes the plugin where context = &#63; from the database.
	 *
	 * @param context the context
	 * @return the plugin that was removed
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public Plugin removeByContext(String context)
		throws NoSuchPluginException, SystemException {
		Plugin plugin = findByContext(context);

		return remove(plugin);
	}

	/**
	 * Returns the number of plugins where context = &#63;.
	 *
	 * @param context the context
	 * @return the number of matching plugins
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public int countByContext(String context) throws SystemException {
		FinderPath finderPath = FINDER_PATH_COUNT_BY_CONTEXT;

		Object[] finderArgs = new Object[] { context };

		Long count = (Long)FinderCacheUtil.getResult(finderPath, finderArgs,
				this);

		if (count == null) {
			StringBundler query = new StringBundler(2);

			query.append(_SQL_COUNT_PLUGIN_WHERE);

			boolean bindContext = false;

			if (context == null) {
				query.append(_FINDER_COLUMN_CONTEXT_CONTEXT_1);
			}
			else if (context.equals(StringPool.BLANK)) {
				query.append(_FINDER_COLUMN_CONTEXT_CONTEXT_3);
			}
			else {
				bindContext = true;

				query.append(_FINDER_COLUMN_CONTEXT_CONTEXT_2);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				if (bindContext) {
					qPos.add(context);
				}

				count = (Long)q.uniqueResult();

				FinderCacheUtil.putResult(finderPath, finderArgs, count);
			}
			catch (Exception e) {
				FinderCacheUtil.removeResult(finderPath, finderArgs);

				throw processException(e);
			}
			finally {
				closeSession(session);
			}
		}

		return count.intValue();
	}

	private static final String _FINDER_COLUMN_CONTEXT_CONTEXT_1 = "plugin.context IS NULL";
	private static final String _FINDER_COLUMN_CONTEXT_CONTEXT_2 = "plugin.context = ?";
	private static final String _FINDER_COLUMN_CONTEXT_CONTEXT_3 = "(plugin.context IS NULL OR plugin.context = '')";
	public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_BY_ACTIVE = new FinderPath(PluginModelImpl.ENTITY_CACHE_ENABLED,
			PluginModelImpl.FINDER_CACHE_ENABLED, PluginImpl.class,
			FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findByActive",
			new String[] {
				Boolean.class.getName(),
				
			Integer.class.getName(), Integer.class.getName(),
				OrderByComparator.class.getName()
			});
	public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_ACTIVE =
		new FinderPath(PluginModelImpl.ENTITY_CACHE_ENABLED,
			PluginModelImpl.FINDER_CACHE_ENABLED, PluginImpl.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "findByActive",
			new String[] { Boolean.class.getName() },
			PluginModelImpl.ACTIVE_COLUMN_BITMASK |
			PluginModelImpl.CONTEXT_COLUMN_BITMASK);
	public static final FinderPath FINDER_PATH_COUNT_BY_ACTIVE = new FinderPath(PluginModelImpl.ENTITY_CACHE_ENABLED,
			PluginModelImpl.FINDER_CACHE_ENABLED, Long.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countByActive",
			new String[] { Boolean.class.getName() });

	/**
	 * Returns all the plugins where active = &#63;.
	 *
	 * @param active the active
	 * @return the matching plugins
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public List<Plugin> findByActive(boolean active) throws SystemException {
		return findByActive(active, QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
	}

	/**
	 * Returns a range of all the plugins where active = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	 * </p>
	 *
	 * @param active the active
	 * @param start the lower bound of the range of plugins
	 * @param end the upper bound of the range of plugins (not inclusive)
	 * @return the range of matching plugins
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public List<Plugin> findByActive(boolean active, int start, int end)
		throws SystemException {
		return findByActive(active, start, end, null);
	}

	/**
	 * Returns an ordered range of all the plugins where active = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	 * </p>
	 *
	 * @param active the active
	 * @param start the lower bound of the range of plugins
	 * @param end the upper bound of the range of plugins (not inclusive)
	 * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	 * @return the ordered range of matching plugins
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public List<Plugin> findByActive(boolean active, int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		boolean pagination = true;
		FinderPath finderPath = null;
		Object[] finderArgs = null;

		if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
				(orderByComparator == null)) {
			pagination = false;
			finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_ACTIVE;
			finderArgs = new Object[] { active };
		}
		else {
			finderPath = FINDER_PATH_WITH_PAGINATION_FIND_BY_ACTIVE;
			finderArgs = new Object[] { active, start, end, orderByComparator };
		}

		List<Plugin> list = (List<Plugin>)FinderCacheUtil.getResult(finderPath,
				finderArgs, this);

		if ((list != null) && !list.isEmpty()) {
			for (Plugin plugin : list) {
				if ((active != plugin.getActive())) {
					list = null;

					break;
				}
			}
		}

		if (list == null) {
			StringBundler query = null;

			if (orderByComparator != null) {
				query = new StringBundler(3 +
						(orderByComparator.getOrderByFields().length * 3));
			}
			else {
				query = new StringBundler(3);
			}

			query.append(_SQL_SELECT_PLUGIN_WHERE);

			query.append(_FINDER_COLUMN_ACTIVE_ACTIVE_2);

			if (orderByComparator != null) {
				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);
			}
			else
			 if (pagination) {
				query.append(PluginModelImpl.ORDER_BY_JPQL);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(active);

				if (!pagination) {
					list = (List<Plugin>)QueryUtil.list(q, getDialect(), start,
							end, false);

					Collections.sort(list);

					list = new UnmodifiableList<Plugin>(list);
				}
				else {
					list = (List<Plugin>)QueryUtil.list(q, getDialect(), start,
							end);
				}

				cacheResult(list);

				FinderCacheUtil.putResult(finderPath, finderArgs, list);
			}
			catch (Exception e) {
				FinderCacheUtil.removeResult(finderPath, finderArgs);

				throw processException(e);
			}
			finally {
				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Returns the first plugin in the ordered set where active = &#63;.
	 *
	 * @param active the active
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the first matching plugin
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginException if a matching plugin could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public Plugin findByActive_First(boolean active,
		OrderByComparator orderByComparator)
		throws NoSuchPluginException, SystemException {
		Plugin plugin = fetchByActive_First(active, orderByComparator);

		if (plugin != null) {
			return plugin;
		}

		StringBundler msg = new StringBundler(4);

		msg.append(_NO_SUCH_ENTITY_WITH_KEY);

		msg.append("active=");
		msg.append(active);

		msg.append(StringPool.CLOSE_CURLY_BRACE);

		throw new NoSuchPluginException(msg.toString());
	}

	/**
	 * Returns the first plugin in the ordered set where active = &#63;.
	 *
	 * @param active the active
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the first matching plugin, or <code>null</code> if a matching plugin could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public Plugin fetchByActive_First(boolean active,
		OrderByComparator orderByComparator) throws SystemException {
		List<Plugin> list = findByActive(active, 0, 1, orderByComparator);

		if (!list.isEmpty()) {
			return list.get(0);
		}

		return null;
	}

	/**
	 * Returns the last plugin in the ordered set where active = &#63;.
	 *
	 * @param active the active
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the last matching plugin
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginException if a matching plugin could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public Plugin findByActive_Last(boolean active,
		OrderByComparator orderByComparator)
		throws NoSuchPluginException, SystemException {
		Plugin plugin = fetchByActive_Last(active, orderByComparator);

		if (plugin != null) {
			return plugin;
		}

		StringBundler msg = new StringBundler(4);

		msg.append(_NO_SUCH_ENTITY_WITH_KEY);

		msg.append("active=");
		msg.append(active);

		msg.append(StringPool.CLOSE_CURLY_BRACE);

		throw new NoSuchPluginException(msg.toString());
	}

	/**
	 * Returns the last plugin in the ordered set where active = &#63;.
	 *
	 * @param active the active
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the last matching plugin, or <code>null</code> if a matching plugin could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public Plugin fetchByActive_Last(boolean active,
		OrderByComparator orderByComparator) throws SystemException {
		int count = countByActive(active);

		if (count == 0) {
			return null;
		}

		List<Plugin> list = findByActive(active, count - 1, count,
				orderByComparator);

		if (!list.isEmpty()) {
			return list.get(0);
		}

		return null;
	}

	/**
	 * Returns the plugins before and after the current plugin in the ordered set where active = &#63;.
	 *
	 * @param pluginId the primary key of the current plugin
	 * @param active the active
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the previous, current, and next plugin
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginException if a plugin with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public Plugin[] findByActive_PrevAndNext(long pluginId, boolean active,
		OrderByComparator orderByComparator)
		throws NoSuchPluginException, SystemException {
		Plugin plugin = findByPrimaryKey(pluginId);

		Session session = null;

		try {
			session = openSession();

			Plugin[] array = new PluginImpl[3];

			array[0] = getByActive_PrevAndNext(session, plugin, active,
					orderByComparator, true);

			array[1] = plugin;

			array[2] = getByActive_PrevAndNext(session, plugin, active,
					orderByComparator, false);

			return array;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	protected Plugin getByActive_PrevAndNext(Session session, Plugin plugin,
		boolean active, OrderByComparator orderByComparator, boolean previous) {
		StringBundler query = null;

		if (orderByComparator != null) {
			query = new StringBundler(6 +
					(orderByComparator.getOrderByFields().length * 6));
		}
		else {
			query = new StringBundler(3);
		}

		query.append(_SQL_SELECT_PLUGIN_WHERE);

		query.append(_FINDER_COLUMN_ACTIVE_ACTIVE_2);

		if (orderByComparator != null) {
			String[] orderByConditionFields = orderByComparator.getOrderByConditionFields();

			if (orderByConditionFields.length > 0) {
				query.append(WHERE_AND);
			}

			for (int i = 0; i < orderByConditionFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByConditionFields[i]);

				if ((i + 1) < orderByConditionFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN_HAS_NEXT);
					}
					else {
						query.append(WHERE_LESSER_THAN_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN);
					}
					else {
						query.append(WHERE_LESSER_THAN);
					}
				}
			}

			query.append(ORDER_BY_CLAUSE);

			String[] orderByFields = orderByComparator.getOrderByFields();

			for (int i = 0; i < orderByFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByFields[i]);

				if ((i + 1) < orderByFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC_HAS_NEXT);
					}
					else {
						query.append(ORDER_BY_DESC_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC);
					}
					else {
						query.append(ORDER_BY_DESC);
					}
				}
			}
		}
		else {
			query.append(PluginModelImpl.ORDER_BY_JPQL);
		}

		String sql = query.toString();

		Query q = session.createQuery(sql);

		q.setFirstResult(0);
		q.setMaxResults(2);

		QueryPos qPos = QueryPos.getInstance(q);

		qPos.add(active);

		if (orderByComparator != null) {
			Object[] values = orderByComparator.getOrderByConditionValues(plugin);

			for (Object value : values) {
				qPos.add(value);
			}
		}

		List<Plugin> list = q.list();

		if (list.size() == 2) {
			return list.get(1);
		}
		else {
			return null;
		}
	}

	/**
	 * Removes all the plugins where active = &#63; from the database.
	 *
	 * @param active the active
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public void removeByActive(boolean active) throws SystemException {
		for (Plugin plugin : findByActive(active, QueryUtil.ALL_POS,
				QueryUtil.ALL_POS, null)) {
			remove(plugin);
		}
	}

	/**
	 * Returns the number of plugins where active = &#63;.
	 *
	 * @param active the active
	 * @return the number of matching plugins
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public int countByActive(boolean active) throws SystemException {
		FinderPath finderPath = FINDER_PATH_COUNT_BY_ACTIVE;

		Object[] finderArgs = new Object[] { active };

		Long count = (Long)FinderCacheUtil.getResult(finderPath, finderArgs,
				this);

		if (count == null) {
			StringBundler query = new StringBundler(2);

			query.append(_SQL_COUNT_PLUGIN_WHERE);

			query.append(_FINDER_COLUMN_ACTIVE_ACTIVE_2);

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(active);

				count = (Long)q.uniqueResult();

				FinderCacheUtil.putResult(finderPath, finderArgs, count);
			}
			catch (Exception e) {
				FinderCacheUtil.removeResult(finderPath, finderArgs);

				throw processException(e);
			}
			finally {
				closeSession(session);
			}
		}

		return count.intValue();
	}

	private static final String _FINDER_COLUMN_ACTIVE_ACTIVE_2 = "plugin.active = ?";

	public PluginPersistenceImpl() {
		setModelClass(Plugin.class);
	}

	/**
	 * Caches the plugin in the entity cache if it is enabled.
	 *
	 * @param plugin the plugin
	 */
	@Override
	public void cacheResult(Plugin plugin) {
		EntityCacheUtil.putResult(PluginModelImpl.ENTITY_CACHE_ENABLED,
			PluginImpl.class, plugin.getPrimaryKey(), plugin);

		FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_CONTEXT,
			new Object[] { plugin.getContext() }, plugin);

		plugin.resetOriginalValues();
	}

	/**
	 * Caches the plugins in the entity cache if it is enabled.
	 *
	 * @param plugins the plugins
	 */
	@Override
	public void cacheResult(List<Plugin> plugins) {
		for (Plugin plugin : plugins) {
			if (EntityCacheUtil.getResult(
						PluginModelImpl.ENTITY_CACHE_ENABLED, PluginImpl.class,
						plugin.getPrimaryKey()) == null) {
				cacheResult(plugin);
			}
			else {
				plugin.resetOriginalValues();
			}
		}
	}

	/**
	 * Clears the cache for all plugins.
	 *
	 * <p>
	 * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
	 * </p>
	 */
	@Override
	public void clearCache() {
		if (_HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE) {
			CacheRegistryUtil.clear(PluginImpl.class.getName());
		}

		EntityCacheUtil.clearCache(PluginImpl.class.getName());

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_ENTITY);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
	}

	/**
	 * Clears the cache for the plugin.
	 *
	 * <p>
	 * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
	 * </p>
	 */
	@Override
	public void clearCache(Plugin plugin) {
		EntityCacheUtil.removeResult(PluginModelImpl.ENTITY_CACHE_ENABLED,
			PluginImpl.class, plugin.getPrimaryKey());

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);

		clearUniqueFindersCache(plugin);
	}

	@Override
	public void clearCache(List<Plugin> plugins) {
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);

		for (Plugin plugin : plugins) {
			EntityCacheUtil.removeResult(PluginModelImpl.ENTITY_CACHE_ENABLED,
				PluginImpl.class, plugin.getPrimaryKey());

			clearUniqueFindersCache(plugin);
		}
	}

	protected void cacheUniqueFindersCache(Plugin plugin) {
		if (plugin.isNew()) {
			Object[] args = new Object[] { plugin.getContext() };

			FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_CONTEXT, args,
				Long.valueOf(1));
			FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_CONTEXT, args, plugin);
		}
		else {
			PluginModelImpl pluginModelImpl = (PluginModelImpl)plugin;

			if ((pluginModelImpl.getColumnBitmask() &
					FINDER_PATH_FETCH_BY_CONTEXT.getColumnBitmask()) != 0) {
				Object[] args = new Object[] { plugin.getContext() };

				FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_CONTEXT, args,
					Long.valueOf(1));
				FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_CONTEXT, args,
					plugin);
			}
		}
	}

	protected void clearUniqueFindersCache(Plugin plugin) {
		PluginModelImpl pluginModelImpl = (PluginModelImpl)plugin;

		Object[] args = new Object[] { plugin.getContext() };

		FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_CONTEXT, args);
		FinderCacheUtil.removeResult(FINDER_PATH_FETCH_BY_CONTEXT, args);

		if ((pluginModelImpl.getColumnBitmask() &
				FINDER_PATH_FETCH_BY_CONTEXT.getColumnBitmask()) != 0) {
			args = new Object[] { pluginModelImpl.getOriginalContext() };

			FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_CONTEXT, args);
			FinderCacheUtil.removeResult(FINDER_PATH_FETCH_BY_CONTEXT, args);
		}
	}

	/**
	 * Creates a new plugin with the primary key. Does not add the plugin to the database.
	 *
	 * @param pluginId the primary key for the new plugin
	 * @return the new plugin
	 */
	@Override
	public Plugin create(long pluginId) {
		Plugin plugin = new PluginImpl();

		plugin.setNew(true);
		plugin.setPrimaryKey(pluginId);

		return plugin;
	}

	/**
	 * Removes the plugin with the primary key from the database. Also notifies the appropriate model listeners.
	 *
	 * @param pluginId the primary key of the plugin
	 * @return the plugin that was removed
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginException if a plugin with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public Plugin remove(long pluginId)
		throws NoSuchPluginException, SystemException {
		return remove((Serializable)pluginId);
	}

	/**
	 * Removes the plugin with the primary key from the database. Also notifies the appropriate model listeners.
	 *
	 * @param primaryKey the primary key of the plugin
	 * @return the plugin that was removed
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginException if a plugin with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public Plugin remove(Serializable primaryKey)
		throws NoSuchPluginException, SystemException {
		Session session = null;

		try {
			session = openSession();

			Plugin plugin = (Plugin)session.get(PluginImpl.class, primaryKey);

			if (plugin == null) {
				if (_log.isWarnEnabled()) {
					_log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY + primaryKey);
				}

				throw new NoSuchPluginException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
					primaryKey);
			}

			return remove(plugin);
		}
		catch (NoSuchPluginException nsee) {
			throw nsee;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	@Override
	protected Plugin removeImpl(Plugin plugin) throws SystemException {
		plugin = toUnwrappedModel(plugin);

		Session session = null;

		try {
			session = openSession();

			if (!session.contains(plugin)) {
				plugin = (Plugin)session.get(PluginImpl.class,
						plugin.getPrimaryKeyObj());
			}

			if (plugin != null) {
				session.delete(plugin);
			}
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}

		if (plugin != null) {
			clearCache(plugin);
		}

		return plugin;
	}

	@Override
	public Plugin updateImpl(it.tref.liferay.mapit.map.model.Plugin plugin)
		throws SystemException {
		plugin = toUnwrappedModel(plugin);

		boolean isNew = plugin.isNew();

		PluginModelImpl pluginModelImpl = (PluginModelImpl)plugin;

		Session session = null;

		try {
			session = openSession();

			if (plugin.isNew()) {
				session.save(plugin);

				plugin.setNew(false);
			}
			else {
				session.merge(plugin);
			}
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);

		if (isNew || !PluginModelImpl.COLUMN_BITMASK_ENABLED) {
			FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
		}

		else {
			if ((pluginModelImpl.getColumnBitmask() &
					FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_ACTIVE.getColumnBitmask()) != 0) {
				Object[] args = new Object[] { pluginModelImpl.getOriginalActive() };

				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_ACTIVE, args);
				FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_ACTIVE,
					args);

				args = new Object[] { pluginModelImpl.getActive() };

				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_ACTIVE, args);
				FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_ACTIVE,
					args);
			}
		}

		EntityCacheUtil.putResult(PluginModelImpl.ENTITY_CACHE_ENABLED,
			PluginImpl.class, plugin.getPrimaryKey(), plugin);

		clearUniqueFindersCache(plugin);
		cacheUniqueFindersCache(plugin);

		return plugin;
	}

	protected Plugin toUnwrappedModel(Plugin plugin) {
		if (plugin instanceof PluginImpl) {
			return plugin;
		}

		PluginImpl pluginImpl = new PluginImpl();

		pluginImpl.setNew(plugin.isNew());
		pluginImpl.setPrimaryKey(plugin.getPrimaryKey());

		pluginImpl.setPluginId(plugin.getPluginId());
		pluginImpl.setCreateDate(plugin.getCreateDate());
		pluginImpl.setModifiedDate(plugin.getModifiedDate());
		pluginImpl.setName(plugin.getName());
		pluginImpl.setVersion(plugin.getVersion());
		pluginImpl.setMapItVersion(plugin.getMapItVersion());
		pluginImpl.setContext(plugin.getContext());
		pluginImpl.setActive(plugin.isActive());

		return pluginImpl;
	}

	/**
	 * Returns the plugin with the primary key or throws a {@link com.liferay.portal.NoSuchModelException} if it could not be found.
	 *
	 * @param primaryKey the primary key of the plugin
	 * @return the plugin
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginException if a plugin with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public Plugin findByPrimaryKey(Serializable primaryKey)
		throws NoSuchPluginException, SystemException {
		Plugin plugin = fetchByPrimaryKey(primaryKey);

		if (plugin == null) {
			if (_log.isWarnEnabled()) {
				_log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY + primaryKey);
			}

			throw new NoSuchPluginException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
				primaryKey);
		}

		return plugin;
	}

	/**
	 * Returns the plugin with the primary key or throws a {@link it.tref.liferay.mapit.map.NoSuchPluginException} if it could not be found.
	 *
	 * @param pluginId the primary key of the plugin
	 * @return the plugin
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginException if a plugin with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public Plugin findByPrimaryKey(long pluginId)
		throws NoSuchPluginException, SystemException {
		return findByPrimaryKey((Serializable)pluginId);
	}

	/**
	 * Returns the plugin with the primary key or returns <code>null</code> if it could not be found.
	 *
	 * @param primaryKey the primary key of the plugin
	 * @return the plugin, or <code>null</code> if a plugin with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public Plugin fetchByPrimaryKey(Serializable primaryKey)
		throws SystemException {
		Plugin plugin = (Plugin)EntityCacheUtil.getResult(PluginModelImpl.ENTITY_CACHE_ENABLED,
				PluginImpl.class, primaryKey);

		if (plugin == _nullPlugin) {
			return null;
		}

		if (plugin == null) {
			Session session = null;

			try {
				session = openSession();

				plugin = (Plugin)session.get(PluginImpl.class, primaryKey);

				if (plugin != null) {
					cacheResult(plugin);
				}
				else {
					EntityCacheUtil.putResult(PluginModelImpl.ENTITY_CACHE_ENABLED,
						PluginImpl.class, primaryKey, _nullPlugin);
				}
			}
			catch (Exception e) {
				EntityCacheUtil.removeResult(PluginModelImpl.ENTITY_CACHE_ENABLED,
					PluginImpl.class, primaryKey);

				throw processException(e);
			}
			finally {
				closeSession(session);
			}
		}

		return plugin;
	}

	/**
	 * Returns the plugin with the primary key or returns <code>null</code> if it could not be found.
	 *
	 * @param pluginId the primary key of the plugin
	 * @return the plugin, or <code>null</code> if a plugin with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public Plugin fetchByPrimaryKey(long pluginId) throws SystemException {
		return fetchByPrimaryKey((Serializable)pluginId);
	}

	/**
	 * Returns all the plugins.
	 *
	 * @return the plugins
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public List<Plugin> findAll() throws SystemException {
		return findAll(QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
	}

	/**
	 * Returns a range of all the plugins.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	 * </p>
	 *
	 * @param start the lower bound of the range of plugins
	 * @param end the upper bound of the range of plugins (not inclusive)
	 * @return the range of plugins
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public List<Plugin> findAll(int start, int end) throws SystemException {
		return findAll(start, end, null);
	}

	/**
	 * Returns an ordered range of all the plugins.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	 * </p>
	 *
	 * @param start the lower bound of the range of plugins
	 * @param end the upper bound of the range of plugins (not inclusive)
	 * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	 * @return the ordered range of plugins
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public List<Plugin> findAll(int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		boolean pagination = true;
		FinderPath finderPath = null;
		Object[] finderArgs = null;

		if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
				(orderByComparator == null)) {
			pagination = false;
			finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_ALL;
			finderArgs = FINDER_ARGS_EMPTY;
		}
		else {
			finderPath = FINDER_PATH_WITH_PAGINATION_FIND_ALL;
			finderArgs = new Object[] { start, end, orderByComparator };
		}

		List<Plugin> list = (List<Plugin>)FinderCacheUtil.getResult(finderPath,
				finderArgs, this);

		if (list == null) {
			StringBundler query = null;
			String sql = null;

			if (orderByComparator != null) {
				query = new StringBundler(2 +
						(orderByComparator.getOrderByFields().length * 3));

				query.append(_SQL_SELECT_PLUGIN);

				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);

				sql = query.toString();
			}
			else {
				sql = _SQL_SELECT_PLUGIN;

				if (pagination) {
					sql = sql.concat(PluginModelImpl.ORDER_BY_JPQL);
				}
			}

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				if (!pagination) {
					list = (List<Plugin>)QueryUtil.list(q, getDialect(), start,
							end, false);

					Collections.sort(list);

					list = new UnmodifiableList<Plugin>(list);
				}
				else {
					list = (List<Plugin>)QueryUtil.list(q, getDialect(), start,
							end);
				}

				cacheResult(list);

				FinderCacheUtil.putResult(finderPath, finderArgs, list);
			}
			catch (Exception e) {
				FinderCacheUtil.removeResult(finderPath, finderArgs);

				throw processException(e);
			}
			finally {
				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Removes all the plugins from the database.
	 *
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public void removeAll() throws SystemException {
		for (Plugin plugin : findAll()) {
			remove(plugin);
		}
	}

	/**
	 * Returns the number of plugins.
	 *
	 * @return the number of plugins
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public int countAll() throws SystemException {
		Long count = (Long)FinderCacheUtil.getResult(FINDER_PATH_COUNT_ALL,
				FINDER_ARGS_EMPTY, this);

		if (count == null) {
			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(_SQL_COUNT_PLUGIN);

				count = (Long)q.uniqueResult();

				FinderCacheUtil.putResult(FINDER_PATH_COUNT_ALL,
					FINDER_ARGS_EMPTY, count);
			}
			catch (Exception e) {
				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_ALL,
					FINDER_ARGS_EMPTY);

				throw processException(e);
			}
			finally {
				closeSession(session);
			}
		}

		return count.intValue();
	}

	@Override
	protected Set<String> getBadColumnNames() {
		return _badColumnNames;
	}

	/**
	 * Initializes the plugin persistence.
	 */
	public void afterPropertiesSet() {
		String[] listenerClassNames = StringUtil.split(GetterUtil.getString(
					com.liferay.util.service.ServiceProps.get(
						"value.object.listener.it.tref.liferay.mapit.map.model.Plugin")));

		if (listenerClassNames.length > 0) {
			try {
				List<ModelListener<Plugin>> listenersList = new ArrayList<ModelListener<Plugin>>();

				for (String listenerClassName : listenerClassNames) {
					listenersList.add((ModelListener<Plugin>)InstanceFactory.newInstance(
							getClassLoader(), listenerClassName));
				}

				listeners = listenersList.toArray(new ModelListener[listenersList.size()]);
			}
			catch (Exception e) {
				_log.error(e);
			}
		}
	}

	public void destroy() {
		EntityCacheUtil.removeCache(PluginImpl.class.getName());
		FinderCacheUtil.removeCache(FINDER_CLASS_NAME_ENTITY);
		FinderCacheUtil.removeCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.removeCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
	}

	private static final String _SQL_SELECT_PLUGIN = "SELECT plugin FROM Plugin plugin";
	private static final String _SQL_SELECT_PLUGIN_WHERE = "SELECT plugin FROM Plugin plugin WHERE ";
	private static final String _SQL_COUNT_PLUGIN = "SELECT COUNT(plugin) FROM Plugin plugin";
	private static final String _SQL_COUNT_PLUGIN_WHERE = "SELECT COUNT(plugin) FROM Plugin plugin WHERE ";
	private static final String _ORDER_BY_ENTITY_ALIAS = "plugin.";
	private static final String _NO_SUCH_ENTITY_WITH_PRIMARY_KEY = "No Plugin exists with the primary key ";
	private static final String _NO_SUCH_ENTITY_WITH_KEY = "No Plugin exists with the key {";
	private static final boolean _HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE = GetterUtil.getBoolean(PropsUtil.get(
				PropsKeys.HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE));
	private static Log _log = LogFactoryUtil.getLog(PluginPersistenceImpl.class);
	private static Set<String> _badColumnNames = SetUtil.fromArray(new String[] {
				"active"
			});
	private static Plugin _nullPlugin = new PluginImpl() {
			@Override
			public Object clone() {
				return this;
			}

			@Override
			public CacheModel<Plugin> toCacheModel() {
				return _nullPluginCacheModel;
			}
		};

	private static CacheModel<Plugin> _nullPluginCacheModel = new CacheModel<Plugin>() {
			@Override
			public Plugin toEntityModel() {
				return _nullPlugin;
			}
		};
}